﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr168_1
{
    // Объявление делегата: 
    delegate void MyDelegate();

    // Класс: 
    class MyClass {
        // Текстовое поле: 
        public string name;
        // Конструктор с текстовым аргументом: 
        public MyClass(string txt) { 
            name = txt;
        }
        // Метод без аргументов: 
        public void show() {
            Console.WriteLine(name);
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Статический метод без аргументов: 
        static void makeLine() {
            Console.WriteLine("--------");
        }
        // Главный метод: 
        static void Main()
        {
            // Создание объектов:
            MyClass A = new MyClass("Объект A");
            MyClass B = new MyClass("Объект B");
            MyClass C = new MyClass("Объект C");
            // Объявление переменной делегата:
            MyDelegate meth;
            // Присваивание переменной делегата ссылки на метод: 
            meth = A.show;
            // Вызов экземпляра делегата: 
            meth();
            // Присваивание переменной делегата нового значения: 
            meth = makeLine;
            // Добавление методов в список вызова:
            meth += A.show;
            meth += B.show;
            meth = meth + C.show;
            // Вызов экземпляра делегата: 
            meth();
            // Удаление метода из списка вызова: 
            meth -= B.show;
            // Вызов экземпляра делегата: 
            meth();
            // Удаление метода из списка вызова: 
            meth = meth - A.show;
            // Вызов экземпляра делегата: 
            meth();
            // Задержка:
            Console.ReadLine();
        }
    }
}
